'use strict';

var _chai = require('chai');

var _createLayout = require('../src/create-layout');

var _createLayout2 = _interopRequireDefault(_createLayout);

var _layouter = require('../src/layouter');

var _layouter2 = _interopRequireDefault(_layouter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getLayoutParams = function getLayoutParams() {
  return {
    styleParams: { oneRow: true },
    container: { width: 100 },
    items: [{ id: '0', width: 50, height: 100 }]
  };
};

describe('createLayout', function () {
  it('should create layout', function () {
    var actual = (0, _createLayout2.default)(getLayoutParams());
    var expected = new _layouter2.default(getLayoutParams()).createLayout();

    (0, _chai.expect)(actual).to.deep.equal(expected);
  });
});